<?php

namespace App\Http\Controllers\API;

use App\Exceptions\HTTPException;
use App\Exceptions\NoPermissionException;
use App\Exceptions\NotLoggedInException;
use App\Exceptions\ResourceNotFound;
use App\Models\Setting;
use App\Models\User;
use Illuminate\Support\Facades\Auth;
use Laravel\Lumen\Routing\Controller as BaseController;
use TaGeSo\APIResponse\Response;

class ServerController extends BaseController
{
    public function getSettings(Response $response) {
        $settings = Setting::getPublicSettings();

        return $response->withData(\App\Http\Resources\API\Setting::collection(collect($settings)));
    }
}
