<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class AppSettingsHiddenAndStopRedirect extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('apps', function (Blueprint $table) {
            $table->boolean('stop_auto_redirect')->default(false)->comment('The user must always click the redirect button, auto redirect dont work any more');
            $table->boolean('hidden_in_app_list')->default(false)->comment('Hide the App in the Users App list');
            $table->boolean('user_cant_remove_app')->default(false)->comment('User see the App in the App list but cant remove it');
        });

        Schema::table('users', function (Blueprint $table) {
           $table->string('password_recovery_code')->nullable()->default(null)->comment('Token to reset the password if lost');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('apps', function (Blueprint $table) {
            $table->dropColumn('stop_auto_redirect');
            $table->dropColumn('hidden_in_app_list');
            $table->dropColumn('user_cant_remove_app');
        });
        Schema::table('users', function (Blueprint $table) {
            $table->dropColumn('password_recovery_code')->nullable()->default(null)->comment('Token to reset the password if lost');
        });

    }
}
